Description

Deletion of an LDAP authentication mode fails without any error message if one or more users use it. An error message should be

displayed.

Associated revisions

Revision 17232 - 2018-03-12 05:31 - Go MAEDA

Deletion of an LDAP authentication mode may fail silently (#28000).

Patch by Go MAEDA.

Revision 17233 - 2018-03-12 05:38 - Go MAEDA

Add error_can_not_delete_auth_source string to locales (#28000).

History

#1 - 2018-01-17 11:39 - Go MAEDA

- Target version set to 4.0.0

Setting target version to 4.0.0.

#2 - 2018-01-17 13:31 - Toshi MARUYAMA

- Target version deleted (4.0.0)

Could you add test?

source:trunk/test/functional/auth_sources_controller_test.rb#L154

#3 - 2018-01-17 14:28 - Go MAEDA

- File show-ldap-deletion-error-v2.diff added

Added an assertion in the test.

#4 - 2018-01-17 14:48 - Toshi MARUYAMA

You can use raw English text and I think you can use "assert_select_error".

source:trunk/test/functional/auth_sources_controller_test.rb#L142

#5 - 2018-01-17 15:10 - Go MAEDA

Toshi MARUYAMA wrote:

You can use raw English text and I think you can use "assert_select_error".

source:trunk/test/functional/auth_sources_controller_test.rb#L142

 Do you think using raw text is better? I think I18n.t is better because we don't have to update the test when the English translation for

error_can_not_delete_auth_source is changed. And we cannot use assert_select_error for the page because there isn't  "div#errorExplanation".

#6 - 2018-01-19 00:42 - Go MAEDA

Toshi MARUYAMA wrote:
You can use raw English text and I think you can use "assert_select_error".

source:trunk/test/functional/auth_sources_controller_test.rb#L142

 I think that checking the flash hash is a common way to test flash notices. Please see 7.7 Testing flash notices on Rails Guides. Also in Redmine, the

same way is used. Examples as follows:

source:tags/3.4.4/test/functional/timelog_controller_test.rb#L678

source:tags/3.4.4/test/functional/timelog_controller_test.rb#L689

source:tags/3.4.4/test/functional/my_controller_test.rb#L362

I think that assert_select_error can be used for validation errors brought by ActiveRecord::Errors object but cannot be used for flash hash.

#7 - 2018-01-19 04:54 - Toshi MARUYAMA

Go MAEDA wrote:

Toshi MARUYAMA wrote:

You can use raw English text and I think you can use "assert_select_error".

source:trunk/test/functional/auth_sources_controller_test.rb#L142

 Do you think using raw text is better?

 Yes. Rails changed behaviour many times. It cannot guarantee test result in the future.

#8 - 2018-01-19 12:42 - Jens Krämer

I agree with Toshi, using the raw text in the assertion is preferable. It simplifies the statement and makes it more obvious what is expected.

#9 - 2018-01-20 03:11 - Go MAEDA

- File show-ldap-deletion-error-v3.diff added

Toshi MARUYAMA and Jens Krämer, thank you for your advice!

I have updated the test to use raw text.

#10 - 2018-01-21 01:31 - Go MAEDA

- Target version set to 4.0.0

I fixed the patch as advised by Toshi and Jens. Setting target version to 4.0.0 again.

#11 - 2018-03-12 05:42 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed.

Files

show-ldap-deletion-error.diff 1.35 KB 2018-01-16 Go MAEDA

show-ldap-deletion-error-v2.diff 1.79 KB 2018-01-17 Go MAEDA

show-ldap-deletion-error-v3.diff 1.8 KB 2018-01-20 Go MAEDA
